using System;
using System.Globalization;
using System.Windows.Data;

namespace CustomAggregateFunction
{
	public class SecondsConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			decimal seconds = System.Convert.ToDecimal(value, culture);
			return GetTime(seconds);
		}

		private String GetTime(Decimal totalSeconds)
		{
			Int32 hours = (Int32) Math.Floor((double) totalSeconds / (double) 3600);
			Int32 minutes = (Int32) Math.Floor((double) (totalSeconds - (hours * 3600)) / (double) 60);
			Int32 seconds = (Int32) totalSeconds - (hours * 3600) - (minutes * 60);

			//return hours + ":" + minutes + ":" + seconds;
			
			//explicitly display single-digit numbers such as 6 minutes as 06 minutes
			return string.Format("{0:00}:{1:00}:{2:00}", hours, minutes, seconds);
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new System.NotImplementedException();
		}
	}
}